#include "system/GlobalVariables.h"
#include "system/ADC_Module.h"
#include <adc.h>

#define Delta 50
#define MaxSamples 50

int i;
int Sum=0;
int Max;
int ADC_Result;
int Samples=0;
int Average;

void ADC_Conversion(void){
	//Max=0;

	Delay10TCYx( 5 ); // Delay for 50TCY
	ConvertADC(); // Start conversion
	while( BusyADC() ); // Wait for completion
	ADC_Result = ReadADC(); // Read result
			
	if (ADC_Result>512+Delta)
		ADC_Result=ADC_Result-512-Delta;
	else if (ADC_Result<512-Delta)
		ADC_Result=512-ADC_Result-Delta;
	else
		ADC_Result=0;

	Sum=Sum+ADC_Result;
	Samples++;
	if (Samples==MaxSamples){
		ADC_Averaging();
		ADC_Output();
	}
}
/*
		for (i=0; i<MaxSamples; i++){ 
			//LATCbits.LATC1 = !LATCbits.LATC1;
			//Delay10KTCYx(100);

			Delay10TCYx( 5 ); // Delay for 50TCY
			ConvertADC(); // Start conversion
			while( BusyADC() ); // Wait for completion
			ADC_Result = ReadADC(); // Read result
			
			

			if (ADC_Result>512+Delta){
				//LATCbits.LATC2 = 1;
				ADC_Result=ADC_Result-512-Delta;
			}
			else if (ADC_Result<512-Delta){
				//LATCbits.LATC0 = 1;
				ADC_Result=512-ADC_Result-Delta;
				//LATCbits.LATC2 = 1;
			}
			else{
				//LATCbits.LATC1 = 1;
				ADC_Result=0;
				//LATDbits.LATD7 = 1;
			}
			
			//Averaging
			Sum=Sum+ADC_Result;

			//Peak Detect
			//if (ADC_Result>Max)
			//	Max=ADC_Result;
	
			//Delay10KTCYx( 1 );
			//Delay1KTCYx( 5 ); // Delay for 1ms
		} 
		
		//Averaging
		Sum=Sum/Samples;
	
		//Peak Detect
		//Sum=Max;

		if (Sum<50){
			currentFace=0;
			//LATCbits.LATC0 = 1;
		}
		else if (Sum <90) {
			currentFace=1;
			//LATCbits.LATC1 = 1;
		}
		else if (Sum <130) {
			currentFace=2;
			//LATCbits.LATC2 = 1;
		}
		
		else if (Sum <170) {
			currentFace=3;
		//	LATCbits.LATC6 = 1;
 		}
/ *		else if (Sum <210) {
			currentFace=4;
		//	LATCbits.LATC7 = 1;
		}
		else if (Sum <250) {
			currentFace=5;
			//LATCbits.LATC7 = 1;
		}* /
		else {
			currentFace=4;
		//	LATDbits.LATD7 =1;
			//Delay10KTCYx( 250 );
		}
		//Delay1KTCYx( 500 );
}*/

void ADC_Averaging(void){
	Average=Sum/Samples;
	Sum=0;
	Samples=0;
}

void ADC_Output(void){
		if (Average<50){
			currentDisplay=0;
			//LATCbits.LATC0 = 1;
		}
		else if (Average <90) {
			currentDisplay=1;
			//LATCbits.LATC1 = 1;
		}
		else if (Average <130) {
			currentDisplay=2;
			//LATCbits.LATC2 = 1;
		}
		
		else if (Average <170) {
			currentDisplay=3;
		//	LATCbits.LATC6 = 1;
		}
		else if (Sum <210) {
			currentDisplay=4;
		//	LATCbits.LATC7 = 1;
		}
		else if (Sum <250) {
			currentDisplay=5;
			//LATCbits.LATC7 = 1;
		}
		else {
			currentDisplay=6;
		//	LATDbits.LATD7 =1;
			//Delay10KTCYx( 250 );
		}
		//Delay1KTCYx( 500 );
}